
public class Biblioteca {

	private String nome;
	private String indirizzo;
	private int codice;
	private Libro[] libri;

	// 1- presentare un opportuno costruttore
	public Biblioteca(String nome, String indirizzo, int codice, int maxLibri) {
		this.nome = nome;
		this.indirizzo = indirizzo;
		this.codice = codice;
		//Un array di libri:
		this.libri = new Libro[maxLibri];
	}

	// 2 - presenti opportuni metodi che permettano di accedere alle variabili di
	// istanza delloggetto (non si considerino i libri)
	public String getNome() {
		return nome;
	}

	public String getIndirizzo() {
		return indirizzo;
	}

	public int getCodice() {
		return codice;
	}

	// 3 - possedere un metodo aggiungi che, dato un oggetto Libro, lo inserisca in
	
	public boolean aggiungi(Libro libro) {
		
		for(int i = 0; i < libri.length; i++) {
			if(libri[i] == null) {
				libri[i] = libro;
				return true;
			}
		}
		return false;
	}

	// 4 - presentare un metodo cerca che, dato il nome di un autore, 
	// restituisca tutti i libri di tale autore allinterno della biblioteca (null se non esistono).
	public Libro[] cerca(String autore) {
		
		int count = 0;
		for(int i = 0; i < libri.length; i++)
			if(libri[i] != null && libri[i].getAutore().equals(autore)) 
				count++;
		
		if(count == 0)
			return null;
		
		Libro[] res = new Libro[count];
		int j = 0; //Indice per l'array "res"
		for(int i = 0; i < libri.length; i++)
			if(libri[i] != null && libri[i].getAutore().equals(autore)) {
				res[j] = libri[i];
				j++;
			}
		return res;
	}

	// 5 - possedere un metodo cancella che, dato il nome di un autore, rimuova
	// dalla biblioteca tutti i libri di tale autore (se presenti).
	public void cancella(String autore) {
		
		for(int i = 0; i < libri.length; i++)
			if(libri[i] != null && libri[i].getAutore().equals(autore)) {
				libri[i] = null;
			}
	}

	// 6 - possedere il metodo toString che restituisca una stringa che fornisca una
	// descrizione della biblioteca, compreso il numero di libri effettivamente
	// presenti.
	public String toString() {
		String libridisponibili = "";
		for(int i = 0; i < libri.length; i++)
			if(libri[i] != null)
				libridisponibili += libri[i].toString() + " ";
				

		return "Biblioteca " + nome + "(" + codice + ") - " + indirizzo + " con libri " + libridisponibili;
	}

}
